/*
 * 
 *
 *               WAMM: Wide Area Metacomputer Manager
 *     CNUCE - Institute of the Italian National Research Council
 *      Authors:  R. Baraglia, M. Cosso, G. Faieta, M. Formica, 
 *                      D. Laforenza, M. Nicosia 
 *                   (C) 1997 All Rights Reserved
 *
 *                              NOTICE
 *
 *
 * Permission is hereby granted, without written agreement and without license
 * or royalty fees, to use, copy, modify, and distribute this software and
 * its documentation for educational and research purpose only, provided that
 * the above copyright notice and the following two paragraphs appear in all
 * copies of this software and in the supporting documentation. No charge,
 * other than an "at-cost" distribution fee, may be charged for copies,
 * derivations, or distributions of this material without the express written
 * consent of the copyright holder.
 * 
 * IN NO EVENT SHALL THE INSTITUTION (CNUCE-CNR) AND THE AUTHORS BE LIABLE TO
 * ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THEINSTITUTION OR THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE.
 *
 * THE INSTITUTION (CNUCE-CNR) AND THE AUTHORS SPECIFICALLY DISCLAIMS ANY 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE AUTHORS HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 *
 * We want thanks Brad Topol of the Georgia Institute of Technology, Atlanta.
 */
 
 
#define MAXLTH         1000
#define MAXP            512

#define INTTYPE           2

#define TRACE_START       1
#define OPEN              2
#define LOAD              3
#define SEND              4
#define PROBE             5
#define RECV              6
#define RECV_BLOCKING     7
#define RECV_WAKING       8
#define MESSAGE           9
#define SYNC             10
#define COMPSTATS        11
#define COMMSTATS        12
#define CLOSE            13
#define TRACE_LEVEL      14
#define TRACE_MARK       15
#define TRACE_MESSAGE    16
#define TRACE_FULL       17
#define TRACE_FLUSH      18
#define TRACE_EXIT       19
#define BLOCK_BEGIN      20
#define BLOCK_END        21
#define TRACE_MARKS      22
#define CLOCK_SYNC       23
#define TFILES           24

#define EVENTMARK        -2
#define EVENTENTRY       -3
#define EVENTEXIT        -4
#define EVENTMESSAGE     -7

#define NOPEN            -11
#define NCLOSE           -12
#define NSEND            -21
#define NRECV            -51
#define NRECVBLOCK       -52
#define NPROBE           -53
#define NWRITE          -221
#define NCLOCKSYNC      -401
#define NBARRIER        -402
#define NLOAD           -503
#define NTRACE          -901
#define NTEVENTS        -902
#define NTFILES         -903
#define NTLEVEL         -904
#define NTMSG           -911
#define NTFLUSH         -912
#define NTFULL          -913

